; colblend.asm
; mic, 2004 | micol972@gmail.com

; Tests the hardware alpha blending effect in mode 0
; Assemble with goldroad 1.7



@textarea $8000000
@include start.asm	


pattern_table
	@incbin colblend.pat
name_table
	@incbin colblend.nam
palette
	@incbin colblend.pal


VSync
  stmfd sp!,{r0-r1}
  mov r0,#$4000000
  add r0,r0,#4		; DISPCNT+4 = DISPSTAT

  VS_loop1
    ldrh r1,[r0]
    ands r1,r1,#1
  bne VS_loop1

  VS_loop2
    ldrh r1,[r0]
    ands r1,r1,#1
  beq VS_loop2

  ldmfd sp!,{r0-r1}
  mov pc,lr




start

bl VSync
bl VSync
bl VSync

mov r0,#$0300
mov r1,#$4000000
str r0,[r1]		; Set mode 0 and enable BG0 and 1


; Transfer palette by DMA
mov r0,#$4000000
orr r0,r0,#$D4		
ldr r1,=palette
mov r2,#$5000000
ldr r3,=$84000080
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Transfer patterns by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=pattern_table
mov r2,#$6000000
ldr r3,=$84000B80
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Transfer names by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=name_table
ldr r2,=$$6003800
ldr r3,=$84000080
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Transfer names by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=name_table
add r1,r1,#512
ldr r2,=$$6004000
ldr r3,=$84000080
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

bl VSync

; Set up the CHR and SCR base blocks for BG0 and BG1
ldr r0,=$04000008
ldr r1,=$0880		; BG0: CHR=0, SCR=8, 256x1 colors
strh r1,[r0],#2
ldr r1,=$0780		; BG1: CHR=0, SCR=7, 256x1 colors
strh r1,[r0]

; Set up the BLDMOD and COLEV registers
ldr r0,=$04000050
ldr r1,=$0241		; Alpha blend BG0 and BG1
strh r1,[r0],#2
ldr r1,=$080B		; Set blending factors to 8/16 and 11/16
strh r1,[r0]



forever
	bl VSync

b forever		



@ltorg			; Dump literal pool
@endarea

