; mode2rot.asm
; mic, 2004 | micol972@gmail.com

; Tests BG2 and BG3 scaling and rotation in mode 2
; Assemble with goldroad 1.7


@textarea $8000000
@include start.asm	



pattern_table
	@incbin rzoom2.pat
name_table
	@incbin rzoom2.nam
palette
	@incbin rzoom2.pal
sinetable
	@incbin sinefix.dat
	

VSync
  stmfd sp!,{r0-r1}
  mov r0,#$4000000
  add r0,r0,#4		; DISPCNT+4 = DISPSTAT

  VS_loop1
    ldrh r1,[r0]
    ands r1,r1,#1
  bne VS_loop1

  VS_loop2
    ldrh r1,[r0]
    ands r1,r1,#1
  beq VS_loop2

  ldmfd sp!,{r0-r1}
  mov pc,lr


	

start

bl VSync
bl VSync
bl VSync

; Set mode 4 and enable BG2 and BG3
mov r0,#$0C00
add r0,r0,#2
mov r1,#$4000000
str r0,[r1]		

; Set up BG2 and BG3
ldr r0,=$0400000C
ldr r1,=$2880		; CHR=0, SCR=8, 256x1 colors, wraparound display
strh r1,[r0],#2
strh r1,[r0]

; Transfer palette by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=palette
mov r2,#$5000000
ldr r3,=$84000080
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Fix color 0
mov r2,#$5000000
mov r1,#0
strh r1,[r2]

; Transfer patterns by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=pattern_table
mov r2,#$6000000
ldr r3,=$84000AB0
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Transfer names by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=name_table
ldr r2,=$$6004000
ldr r3,=$84000040
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Set up the BLDMOD and COLEV registers
ldr r0,=$04000050
ldr r1,=$0844		; Alpha blend BG2 and BG3
strh r1,[r0],#2
ldr r1,=$0909		; Set blending factors to 8/16 and 11/16
strh r1,[r0]


ldr r0,=sinetable
mov r1,#0

mov r2,#256		; zoom
mov r3,#1

ldr r4,=0x3FF

ldr r12,=19200
mov r6,#0

forever
	bl VSync

	add r7,r1,#0x100
	and r7,r7,r4
	ldr r8,[r0,r7]	; cos theta
	ldr r9,[r0,r1]	; sin theta

	mul r8,r8,r2	; cos * zoom
	mul r10,r9,r2	; sin * zoom
	mov r8,r8,asr#8
	mov r10,r10,asr#8
	rsb r9,r10,#0	; -sin * zoom
	
	ldr r5,=0x4000020
	strh r8,[r5],#2
	strh r10,[r5],#2
	strh r9,[r5],#2
	strh r8,[r5]

	mov r5,#120
	mov r7,#80
	mul r11,r8,r7

	mul r8,r8,r5
	mul r9,r9,r5
	mul r10,r10,r7
	add r8,r8,r10
	add r9,r9,r11
	rsb r8,r8,r12
	rsb r9,r9,r6
	ldr r7,=0x4000028
	str r8,[r7],#4
	str r9,[r7]

	ldr r11,=576
	sub r11,r11,r2
	add r10,r1,0x200
	add r7,r10,#0x100
	and r10,r10,r4
	and r7,r7,r4
	ldr r8,[r0,r7]	; cos theta
	ldr r9,[r0,r10]	; sin theta
	add r1,r1,#4
	and r1,r1,r4
	mul r8,r8,r11	; cos * zoom
	mul r10,r9,r11	; sin * zoom
	mov r8,r8,asr#8
	mov r10,r10,asr#8
	rsb r9,r10,#0	; -sin * zoom
	
	ldr r5,=0x4000030
	strh r8,[r5],#2
	strh r10,[r5],#2
	strh r9,[r5],#2
	strh r8,[r5]

	mov r5,#120
	mov r7,#80
	mul r11,r8,r7
	mul r8,r8,r5
	mul r9,r9,r5
	mul r10,r10,r7
	add r8,r8,r10
	add r9,r9,r11
	rsb r8,r8,r12
	rsb r9,r9,r6
	ldr r7,=0x4000038
	str r8,[r7],#4
	str r9,[r7]
	
	
	add r2,r2,r3
	cmp r2,#512
	rsbeq r3,r3,#0
	cmp r2,#64
	rsbeq r3,r3,#0
b forever		



@ltorg			; dump literal pool
@endarea

