; mode4rot.asm
; mic, 2004 | micol972@gmail.com

; Tests BG2 scaling and rotation in mode 4
; Assemble with goldroad 1.7


@textarea $8000000
@include start.asm	



bitmap
	@incbin mega.raw
palette
	@incbin mega.pal
sinetable
	@incbin sinefix.dat
	

VSync
  stmfd sp!,{r0-r1}
  mov r0,#$4000000
  add r0,r0,#4		; DISPCNT+4 = DISPSTAT

  VS_loop1
    ldrh r1,[r0]
    ands r1,r1,#1
  bne VS_loop1

  VS_loop2
    ldrh r1,[r0]
    ands r1,r1,#1
  beq VS_loop2

  ldmfd sp!,{r0-r1}
  mov pc,lr


	

start

bl VSync
bl VSync
bl VSync

; Set mode 4 and enable BG2
mov r0,#$0400
add r0,r0,#4
mov r1,#$4000000
str r0,[r1]		

; Transfer palette by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=palette
mov r2,#$5000000
ldr r3,=$84000100
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Transfer bitmap by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=bitmap
mov r2,#$6000000
ldr r3,=$84002580
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]


ldr r0,=sinetable
mov r1,#0

mov r2,#256		; zoom
mov r3,#1

ldr r4,=0x3FF

ldr r12,=19200
mov r6,#0

forever
	bl VSync

	add r7,r1,#0x100
	and r7,r7,r4
	ldr r8,[r0,r7]	; cos theta
	ldr r9,[r0,r1]	; sin theta

	add r1,r1,#4
	and r1,r1,r4
	mul r8,r8,r2	; cos * zoom
	mul r10,r9,r2	; sin * zoom
	mov r8,r8,asr#8
	mov r10,r10,asr#8
	rsb r9,r10,#0	; -sin * zoom
	
	ldr r5,=0x4000020
	strh r8,[r5],#2
	strh r10,[r5],#2
	strh r9,[r5],#2
	strh r8,[r5]

	mov r5,#120
	mov r7,#80
	mul r11,r8,r7

	mul r8,r8,r5
	mul r9,r9,r5
	mul r10,r10,r7
	add r8,r8,r10
	add r9,r9,r11
	rsb r8,r8,r12
	rsb r9,r9,r6
	ldr r7,=0x4000028
	str r8,[r7],#4
	str r9,[r7]
	
	;add r6,r6,#120
	
	add r2,r2,r3
	cmp r2,#512
	rsbeq r3,r3,#0
	cmp r2,#64
	rsbeq r3,r3,#0
b forever		



@ltorg			; dump literal pool
@endarea

