; mosaik.asm
; mic, 2004 | micol972@gmail.com

; Tests mosaic effects on BG2 in mode 4
; Assemble with goldroad 1.7


@textarea $8000000
@include start.asm	



bitmap
	@incbin mega.raw
palette
	@incbin mega.pal


VSync
  stmfd sp!,{r0-r1}
  mov r0,#$4000000
  add r0,r0,#4		; DISPCNT+4 = DISPSTAT

  VS_loop1
    ldrh r1,[r0]
    ands r1,r1,#1
  bne VS_loop1

  VS_loop2
    ldrh r1,[r0]
    ands r1,r1,#1
  beq VS_loop2

  ldmfd sp!,{r0-r1}
  mov pc,lr


	

start

bl VSync
bl VSync
bl VSync

; Set mode 4 and enable BG2
mov r0,#$0400
add r0,r0,#4
mov r1,#$4000000
str r0,[r1]		

; Enable mosaic effects for BG2
ldr r0,=$400000C
mov r1,#$40
strh r1,[r0]

;mov 	r0,#$04000000
;orr	r0,r0,#$130
;mov r4,#$FF
;strh r4,[r0]

; Transfer palette by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=palette
mov r2,#$5000000
ldr r3,=$84000100
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Transfer bitmap by DMA
mov r0,#$4000000
orr r0,r0,#$D4
ldr r1,=bitmap
mov r2,#$6000000
ldr r3,=$84002580
str r1,[r0],#4
str r2,[r0],#4
str r3,[r0]

; Store mosaic size values in IWRAM
mov r8,#$3000000
mov r1,#0
strb r1,[r8]

mov r9,#6		; Delay
mov r10,#$11		; Delta
mov r11,#0		; Up/down flipflop

forever
	bl VSync

	subs r9,r9,#1	; Time for another size change?
	bne forever	; Nope

	mov r9,#6
	ldrb r1,[r8]
	cmp r11,#0
	addeq r1,r1,r10
	subne r1,r1,r10

	strb r1,[r8]
	ldr r0,=$400004C
	strh r1,[r0]

	cmp r1,#$FF
	eoreq r11,r11,#1
	cmp r1,#$00
	eoreq r11,r11,#1
	bleq Delay
b forever		



@ltorg			; dump literal pool
@endarea

