; oamtest.asm
; mic, 2004 | micol972@gmail.com

; Tests 256x1 and 16x16 color OBJs in mode 4
; Assemble with goldroad 1.7



@textarea $8000000
@include start.asm	

font1:
	@incbin font2.pat
font2:
	@incbin font2_16.pat
palette:
	@incbin font2.pal

msg1:
	@dcb "SWIZZLE",0
msg2:
	@dcb "STICKS",0



VSync
  stmfd sp!,{r0-r1}
  mov r0,#$4000000
  add r0,r0,#4		; DISPCNT+4 = DISPSTAT

  VS_loop1
    ldrh r1,[r0]
    ands r1,r1,#1
  bne VS_loop1

  VS_loop2
    ldrh r1,[r0]
    ands r1,r1,#1
  beq VS_loop2

  ldmfd sp!,{r0-r1}
  mov pc,lr




start

bl VSync
bl VSync
bl VSync

ldr r0,=0x1404
mov r1,#$4000000
str r0,[r1]		; Set mode 4 and enable BG2 and OBJ


; Copy palette data
ldr r0,=palette
ldr r1,=0x05000200
mov r2,#0x200
copy_palette:
	ldr r3,[r0],#4
	str r3,[r1],#4
	subs r2,r2,#4
	bne copy_palette


; Copy 256x1 color font
ldr r0,=font1
ldr r1,=0x06014000
mov r2,#0x800
copy_tiles1:
	ldr r3,[r0],#4
	str r3,[r1],#4
	subs r2,r2,#4
	bne copy_tiles1


; Copy 16x16 color font
ldr r0,=font2
mov r2,#0x400
copy_tiles2:
	ldr r3,[r0],#4
	str r3,[r1],#4
	subs r2,r2,#4
	bne copy_tiles2


; Print the first string (256x1 colors)	
ldr r0,=msg1
ldr r1,=0x07000000
mov r2,#68
mov r3,#76
orr r3,r3,#0x2000
puts1:
	ldrb r4,[r0],#1	; Load a character
	ands r4,r4,r4
	beq end_puts1	; Break the loop when we get a null character
	sub r4,r4,#65	; Subtract 65 (font starts at 'A')
	add r4,r4,r4	; Multiply by 2
	add r4,r4,#512	; Add tile base
	strh r3,[r1],#2	; Store Y and 256x1 color flag
	strh r2,[r1],#2	; Store X
	strh r4,[r1],#4	; Store tile number
	add r2,r2,#8	; X += 8
	b puts1
end_puts1:


; Print the second string (16x16 colors)
ldr r0,=msg2
mov r3,#76
puts2:
	ldrb r4,[r0],#1
	ands r4,r4,r4
	beq forever
	sub r4,r4,#65
	add r4,r4,#64	
	add r4,r4,#512
	strh r3,[r1],#2
	strh r2,[r1],#2
	strh r4,[r1],#4
	add r2,r2,#8
	b puts2
	

forever
	bl VSync
	b forever		



@ltorg			; Dump literal pool
@endarea

